
* Jared Still
* (209) 454-8803
* compuserve ID 73617,3036

*--* testvfry.prg
*--* this program demonstrates a way of taming full screen reads in foxbase.
*--* I designed this due to the frustration felt at being unable to do any
*--* processing between fields in a full screen read.  This is something
*--* rather easy to do in basic with proper use of the 'ON GOTO' statement.
*--* this program will allow 2 ways of doing a full screen read - the
*--* traditional xbase way in which the user exits the screen by going
*--* backwards from the first field ( up arrow ) or by exiting the last
*--* field, or hitting ESC, CTRL-W, etc...

*--* it also allows for a continuous read loop in which the only way to exit
*--* is by ESC, CTRL-W, etc...
*--* this way the user may continuously cycle through all fields until ready
*--* to exit
*--* set the variable 'contread' to .t. for this to work

*--* also included is a UDF called 'verify' which may be used in a 'valid'
*--* clause in a READ to look up and verify data in a table
*--* be careful how you use this as the FoxBase manual contains a strong
*--* warning about changing the state of an open database in UDF's,
*--* although I have not experienced any problem with simply reading the file

*--* included in this program is code that will auto create the test files
*--* if they do not already exist
*--* this section of code was produced by a program found on CompuServ,
*--* called DB2PRG, written by Carlos Berguidos

*--* any comments or suggestions please leave compuserve email for me or call


CLEAR
whichproc = SYS(16)
SET PROC TO &whichproc

SET TALK OFF
SET ECHO OFF
SET STATUS OFF
SET BELL OFF

*--* autocreate test data bases and index if they do not exist
* makedbf code produced by Carlos Berguido's db2prg program

IF ! FILE('TESTVER.DBF') .OR. ! FILE('TESTDATA.DBF')
   * MAKEDBF.PRG Creates missing dbf files.  Requires FoxBASE+ or FoxPro
   PRIVATE mscreen, mtalk, msafe, fstrutxt, fstrudbf, mconfirm
   SAVE SCREEN TO mscreen
   SET CONSOLE OFF
   mtalk=SYS(2001,"TALK")
   SET TALK OFF
   msafe=SYS(2001,"SAFETY")
   SET SAFETY OFF
   mscore=SYS(2001,"SCOREBOARD")
   SET SCOREBOARD OFF
   mstatus=SYS(2001,"STATUS")
   IF mstatus="ON"
      SET STATUS OFF
   ENDIF
   fstrutxt=SYS(3)+".txt"
   fstrudbf=SYS(3)+".dbf"
   IF "FOXPRO"$UPPER(VERSION())
      mconfirm=CHR(13)
   ELSE
      mconfirm=""
   ENDIF
   CLEAR TYPEAHEAD
   KEYBOARD "FIELD_NAME" +mconfirm+"C10"  +CHR(13)
   KEYBOARD "FIELD_TYPE" +mconfirm+"C1"   +CHR(13)
   KEYBOARD "FIELD_LEN"  +CHR(13)+ "N3"   +CHR(13)+ "0" +CHR(13)
   KEYBOARD "FIELD_DEC"  +CHR(13)+ "N3"   +CHR(13)+ "0" +CHR(13)+CHR(13)+CHR(13)+"N"
   CREATE &fstrudbf
   RESTORE SCREEN FROM mscreen
   * Draw alert box:
   @ 10,29 CLEAR TO 12,50
   @ 10,29 TO 12,50 DOUBLE
   @ 11,31 SAY "Creating: "
   IF .NOT. FILE("testver.dbf")
      @ 11,41 CLEAR TO 11,49
      @ 11,41 SAY UPPER("testver")
      SET ALTERNATE TO &fstrutxt
      SET ALTERNATE ON
      TEXT
VERDATA   C  4  0
      ENDTEXT
      CLOSE ALTERNATE
      USE &fstrudbf
      ZAP
      APPEND FROM &fstrutxt SDF   FOR field_name<>" "
      USE
      CREATE testver FROM &fstrudbf
      APPEND BLANK
      REPLACE verdata WITH '1000'
      APPEND BLANK
      REPLACE verdata WITH '1020'
      APPEND BLANK
      REPLACE verdata WITH '1238'
      APPEND BLANK
      REPLACE verdata WITH '2000'
      APPEND BLANK
      REPLACE verdata WITH '2398'
      INDEX ON verdata TO testver
   ENDIF
   IF .NOT. FILE("testdata.dbf")
      @ 11,41 CLEAR TO 11,49
      @ 11,41 SAY UPPER("testdata")
      SET ALTERNATE TO &fstrutxt
      SET ALTERNATE ON
      TEXT
FIELD1    C  4  0
FIELD2    C  4  0
FIELD3    C  4  0
      ENDTEXT
      CLOSE ALTERNATE
      USE &fstrudbf
      ZAP
      APPEND FROM &fstrutxt SDF   FOR field_name<>" "
      USE
      CREATE testdata FROM &fstrudbf
      APPEND BLANK
   ENDIF
   SET CONSOLE ON
   USE
   DELE FILE &fstrudbf
   DELE FILE &fstrutxt
   IF msafe="ON"
      SET SAFETY ON
   ENDIF
   IF mtalk="ON"
      SET TALK ON
   ENDIF
   IF mscore="ON"
      SET SCOREBOARD ON
   ENDIF
   IF mstatus="ON"
      SET STATUS ON
   ENDIF
   RESTORE SCREEN FROM mscreen
   *--* end of auto-create section
ENDIF ( file testver or testdata )



*--* this file is used to verify data
*--* for test purposes this should only have 4 or 5 records as
*--* they show on the screen
SELE B
USE testver INDEX testver
@ 0,0 SAY 'this is the data in testver'
LIST

SELE A
USE testdata


isvalid=.F.
fieldnum = 1
contread = .f.  && continuous read flag

@ 4,60 TO 6,70 CLEAR
@ 4,60 TO 6,70
@ 5,62 SAY 'FIELD'


*--* paint the screen first as the read section does ONE field at a time
@ 10,10 SAY 'this field must match a record in testver ' GET field1 VALID Verify(isvalid,'field1')
@ 11,10 SAY 'this field must NOT be found in testver   ' GET field2 VALID Verify(isvalid,'field2')
@ 12,10 SAY 'this field must be in testver and > 2000  ' GET field3 VALID Verify(isvalid,'field3')
CLEAR GETS

DO WHILE .T.
   DO CASE
      
   CASE fieldnum = 0  && used to exit the do loop
      EXIT
      
   CASE fieldnum = 1
      
      * using this method for full screen reads you may put any
      * processing you want BETWEEN fields
      
      @ 5,67 SAY LTRIM(STR(fieldnum,1,0))
      @ 10,10 SAY 'this field must match a record in testver ' GET field1 VALID Verify(isvalid,'field1')
      READ
      fieldnum=exitkey(fieldnum)
      
   CASE fieldnum = 2
      @ 5,67 SAY LTRIM(STR(fieldnum,1,0))
      @ 11,10 SAY 'this field must NOT be found in testver   ' GET field2 VALID Verify(isvalid,'field2')
      READ
      fieldnum=exitkey(fieldnum)
      
   CASE fieldnum = 3 .OR. fieldnum = -1

      && set to - 1 if you are
      && setup in a continuous read loop
      && use this on last field in loop
      && see comments in exitkey procedure

      && set equal to whatever last fieldnum is - a (-1) will mess up
      && the exitkey() routine the next time it is called
      fieldnum = 3

      @ 5,67 SAY LTRIM(STR(fieldnum,1,0))
      @ 12,10 SAY 'this field must be in testver and > 2000  ' GET field3 VALID Verify(isvalid,'field3')
      READ
      fieldnum=exitkey(fieldnum)
      
   OTHERWISE
      
      IF contread
         fieldnum = 1
      ELSE
         EXIT
      ENDIF
      * use exit here to exit the read loop
      * set 'fieldnum' equal to 1 to go to top of loop
      * when fieldnum greater that largest fieldnum in 'do case'
      
   ENDCASE
   
ENDDO

SUSPEND && end of program

*--* this procedure determines how user left the field
PROCEDURE exitkey
PARAMETERS fieldnum
PRIVATE fieldnum
*--* find how user left current field and update the field number

whichkey = ' ' + LTRIM(STR(Readkey())) + ' '

DO CASE
   
   *--* to previous field
CASE whichkey $ ' 0 2 258 4 260 '
   fieldnum = fieldnum - 1
   *--* if continuous read flag is set and fieldnum = 0
   *--* then set fieldnum = -1 so that when then user
   *--* exits to the previous field from the top field in the loop
   *--* the will be sen to the bottom of the loop
   *--* the only way to exit the continous read loop is to exit
   *--* with <ESC> or <CTRL> <END> or <CTRL) <W>
   IF contread .AND. fieldnum = 0
      fieldnum = -1
   ENDIF
   
   *--* to next field
CASE whichkey $ ' 1 257 3 259 5 261 15 271 16 272 '
   fieldnum = fieldnum + 1
   
   *--* ESC or CTRL W or CTRL END
CASE whichkey $ ' 12 268 14 270 '
   fieldnum = 0
   
ENDCASE

RETURN(fieldnum)

*--* this procedure is used in valid statements to verify that data
*--* entered by user exists in a pre-defined database
*--* the parameters are a logical field and the name of the field that
*--* the READ is currently on

*--* be careful what you do in this routine as the FoxBase manual
*--* says that changing the state of open databases in a UDF is a no-no

PROCEDURE Verify
PARAMETERS isvalid,whichfld
PRIVATE isvalid
whichfld=UPPER(whichfld)

oldalias=ALIAS()
lookfor = &whichfld

DO CASE
   
CASE whichfld = 'FIELD1'
   
   SELE B
   SEEK  lookfor
   IF ! FOUND()
      isvalid=.F.
   ELSE
      isvalid = .T.
   ENDIF
   
CASE whichfld = 'FIELD2'
   SELE B
   SEEK  lookfor
   IF ! FOUND()
      isvalid=.T.
   ELSE
      isvalid = .F.
   ENDIF
   
CASE whichfld='FIELD3'
   SELE B
   SEEK  lookfor
   IF  FOUND()  .AND. lookfor > '2000'
      isvalid=.T.
   ELSE
      isvalid = .F.
   ENDIF
ENDCASE

SELE &oldalias

RETURN(isvalid)

